//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

#include <ethernet.h>

//Prototype
void ip (char *);

//Aufbau eines IP Datagramms (B=BIT)
//	
//4B Version	|4B Headergr.	|8B Tos	|16B Gesamtlnge in Bytes	
//16B Identifikation			|3B Schalter	|13B Fragmentierungsposition
//8B Time to Live	|8B Protokoll	|16B Header Prfsumme 
//32B IP Quelladresse
//32B IB Zieladresse
//
//*** Nutzlast ***

//IP Header Layout
#define	IP_VERS_LEN				0x0E	//4 BIT Die Versionsnummer von IP, meistens also 4 + 4Bit Headergre 	
#define	IP_TOS					0x0F	//Type of Service
#define	IP_PKTLEN				0x10	//16 Bit Komplette Lng des IP Datagrams in Bytes
#define	IP_ID					0x12	//ID des Packet fr Fragmentierung oder Reassemblierung	
#define	IP_FRAG_OFFSET			0x14	//wird benutzt um ein fragmentiertes IP Packet wieder korrekt zusammenzusetzen	
#define	IP_TTL					0x16	//8 Bit Time to Live die lebenszeit eines Paket
#define	IP_PROTO				0x17	//Zeigt das hherschichtige Protokoll an (TCP, UDP, ICMP)	
#define	IP_HDR_CKSUM			0x18	//Checksumme des IP Headers	
#define	IP_SRCADDR				0x1A	//32 Bit IP Quelladresse
#define	IP_DESTADDR				0x1E	//32 Bit IP Zieladresse
#define	IP_DATA					0x22	//beginn der IP Daten (hier fngt dann UDP TCP oder ICMP an)	

//IP Protocol Types
#define	PROT_ICMP				0x01	//zeigt an die Nutzlasten enthalten das ICMP Protokoll
#define	PROT_TCP				0x06	//zeigt an die Nutzlasten enthalten das TCP Protokoll
#define	PROT_UDP				0x11	//zeigt an die Nutzlasten enthalten das UDP Protokoll


